/****************************TEMPERATURE***************************/

// Read out temperature from ADC

void read_temperature(void)
{
    uint8_t i;
    temperature=0;
    for (i=0;i<5;i++)
        {
        ADCSRA |= (1<<ADSC);
        //read out adc
        while (ADCSRA & (1<<ADSC))
            {
            }
        if ((ADC+SENSOROFFSET) > SENSORNULL)
            temperature+=ADC;
        }
    //average of 5 readings
    temperature = temperature / 5;
    
    //correction via temperature offset
    if (tempoffset <= 15 && temperature > 15)
        temperature = temperature - (15 - tempoffset);
    else
        temperature = temperature + (tempoffset - 15);
    
    if (temperature > 0 && temperature < 950)
        {
        //simple calculation for temp including correction factors.
        //1000 100.0 degress spreading without "." 
        temperature = ((temperature+SENSOROFFSET)-SENSORNULL)*1000/(SENSOR100-SENSORNULL);
        rgb_temperature = temperature / 10;
        }
    else
        {
        temperature = 0;
        rgb_temperature = 0;
        }
}


